// Sets v 2.00
// Hubert Chan, Nov 13, 1997

#include <iostream.h>

#ifndef __SETS_
#define __SETS_

//#define MAXELEMENT  6   // The largest possible element
//#define MINELEMENT -3   // The smallest possible element

#define INTSIZE sizeof(int) * 8

#define SET_INIT(min, max) int const Set::maxelement = max; \
 int const Set::minelement = min; \
 int const Set::numelements = max - min + 1; \
 int const Set::setsize = (numelements + INTSIZE - 1) / INTSIZE;

class Set {
public:
  typedef int SetElement;
private:
  static int const maxelement;
  static int const minelement;
  static int const numelements;
  static int const setsize;
  //#define NUMELEMENTS MAXELEMENT - MINELEMENT + 1
  //#define SETELEMENTSIZE ((NUMELEMENTS + 7) / 8)
  int *SetElements;
  void AddElem(SetElement);    // add an element to the set
  void RemoveElem(SetElement); // removes an element from the set
  void ClearSet();             // creates the empty set
public:
  Set() : SetElements(new int[setsize]) {
    ClearSet();
  }

  Set(int size, SetElement *Elements) : SetElements(new int[setsize]) {
    int counter;
    ClearSet();
    for(counter = 0; counter < size; counter++) {
      AddElem(Elements[counter]);
    }
  }

  Set(SetElement Element) : SetElements(new int[setsize]) {
    ClearSet();
    AddElem(Element);
  }

  Set(Set const & Set2);

  ~Set() {
    delete [] SetElements;
  }

  int Card() const; // cardinality

  Set operator=(Set const &);        // assignment
  Set operator+(Set const &) const;  // union
  Set operator|(Set const &) const;  // union
  Set operator+(SetElement) const;   // add an element
  Set operator|(SetElement) const;   // add an element
  Set operator+=(Set const &);
  Set operator|=(Set const &);
  Set operator+=(SetElement);
  Set operator|=(SetElement);
  Set operator-();                   // complement
  Set operator~();                   // complement
  Set operator*(Set const &) const;  // intersection
  Set operator^(Set const &) const;  // intersection
  Set operator&(Set const &) const;  // intersection
  Set operator*=(Set const &);
  Set operator^=(Set const &);
  Set operator&=(Set const &);
  Set operator-(Set const &) const;  // intersection of complement (difference)
  Set operator-(SetElement) const;   // remove an element
  Set operator-=(Set const &);
  Set operator-=(SetElement);
  int operator==(Set const &) const; // equivalence
  int operator!=(Set const &) const; // inequivalence
  int operator<=(Set const &) const; // subset
  int operator<(Set const &) const;  // proper subset
  int operator>=(Set const &) const; // superset
  int operator>(Set const &) const;  // proper superset
  friend int operator<=(SetElement, Set const &); // element

  friend void PrintSet(Set const &);
  friend ostream& operator<<(ostream &, Set const &);

};

#endif
